org.apache.tapestry5.ioc

## Interface ObjectProvider

- All Known Implementing Classes:
    ApplicationMessageCatalogObjectProvider, AssetObjectProvider, AutobuildObjectProvider, EntityManagerObjectProvider, ServiceAnnotationObjectProvider, StaticObjectProvider, SymbolObjectProvider, ValueObjectProvider

      public interface ObjectProvider

  Object providers represent an alternate way to locate an object provided somewhere in the `Registry`. Instead of using a just the service id to gain access to a service within the Registry, object providers in different flavors are capable of vending, or even creating, objects of disparate types from disparate sources. Object providers are consulted in a strict order, and the first non-null result is taken. In many cases, an object provider searches for additional annotations on the element (usually a parameter, or perhaps a field) for which a value is required.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> T` | `provide(Class<T> objectType, AnnotationProvider annotationProvider, ObjectLocator locator)` Provides an object based on an expression.

- - ### Method Detail

    - #### provide

          <T> T provide(Class<T> objectType,
                        AnnotationProvider annotationProvider,
                        ObjectLocator locator)

      Provides an object based on an expression. The process of providing objects occurs within a particular context, which will typically be a service builder method, service contributor method, or service decorator method. The locator parameter provides access to the services visible to that context.
      Type Parameters:
        `T` -
      Parameters:
        `objectType` - the expected object type
        `annotationProvider` - provides access to annotations (typically, the field or parameter to which an injection-related annotation is attached); annotations on the field or parameter may also be used when resolving the desired object
        `locator` - locator for the context in which the provider is being used
      Returns:
        the requested object, or null if this object provider can not supply an object
      Throws:
        `RuntimeException` - if the expression can not be evaluated, or the type of object identified is not assignable to the type specified by the objectType parameter

5.6.0 - Copyright © 2003-2020 The Apache Software Foundation.